#include <stderror.mqh>
//+------------------------------------------------------------------+
//|                                              Test UCHEBNIK 2.mq4 |
//|                                     Copyright 2013, Klonoz Denis |
//|                        skype-denis77515  http://cool-master.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, Klonoz Denis"
#property link      "skype-denis77515  http://cool-master.net/"

extern bool    Hvkl            = true; //   , (. )
extern int     HaurStart       = 10;   // 
extern int     HaurEnd         = 19;   // 
extern double  Lots            =  0.1;
extern double  MaximumRisk     = 0.03;  //    500  +0.1 .    1000  =0.2, 1500  =0.3 
extern double  DecreaseFactor  = 3.0;
extern double  balans          = 500; //  
extern int     Slippage        = 5;
extern int     IndentSL        = 10;
extern int     IndentTP        = 2;
extern int     Magic           = 123;
extern string  ____            = "           <<<=====   =====>>>";
extern string  _____           = "           <<<===============================>>>";
extern string  __1__           = "           <<<=    =>>>";
extern double  period_ema      = 21;
extern int     timeframe       = 60;
extern string  ______          = "";
extern double  period_ema_1    = 21;
extern int     timeframe_1     = 15;
extern string  __2__           = "          ==<<<  Bollinger Bands >>>==";
extern string TimeFrame       = "current time frame";
extern int    HalfLength      = 56;
extern int    Price           = PRICE_CLOSE;
extern double ATRMultiplier   = 2.0;
extern int    ATRPeriod       = 100;
extern bool   Interpolate     = true;

double SL,TP,bbUP,bbDWN,E_ma,e_ma,vhod;
int timeprev;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
if (Digits == 3|| Digits == 5)
{
Slippage   *=10;
IndentSL   *=10;
IndentTP   *=10;
}
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  CloseOrders();
  if ((Hvkl == true && (Hour() >= HaurStart && Hour() <= HaurEnd)) || Hvkl == false)
  {
       if(timeprev == Time[0]) return(0);
       timeprev = Time[0];
  //double vhod=iClose(Symbol(),PERIOD_M5,1);
   e_ma=iMA(Symbol(),PERIOD_M15,period_ema_1,0,MODE_EMA,PRICE_CLOSE,1);
   E_ma=iMA(Symbol(),PERIOD_H1,period_ema,0,MODE_EMA,PRICE_CLOSE,1);
   bbUP=iCustom(Symbol(),PERIOD_M5,"TMA with Distances",TimeFrame,HalfLength,Price,ATRMultiplier,ATRPeriod,Interpolate,1,0);
   bbDWN=iCustom(Symbol(),PERIOD_M5,"TMA with Distances",TimeFrame,HalfLength,Price,ATRMultiplier,ATRPeriod,Interpolate,2,0);
         
         
         
         if(OrdersTotal()==0 && CountBuy()==0 &&  CountSell())
         {
     
           if(Bid==(timeprev <= bbDWN) && (E_ma >= e_ma)) //          
           //       .
           
         {
         int ticket=OrderSendX(Symbol(),OP_BUY,Lots,Ask,Slippage,0,0,"",Magic,0,Green);
         if(ticket>0)
         {
              SL = NormalizeDouble(bbDWN - IndentSL * Point , Digits);
              //TP = NormalizeDouble(bbUP+IndentTP * Point , Digits);
              OrderModifyX(ticket, OrderOpenPrice(), SL, 0, 0);
         }//if(ticket>0)
         }//if(Ask>=(e_ma>=E_ma) && (bbDWN<=vhod))
         //else
           if(Bid==(timeprev >= bbUP) && (E_ma <= e_ma)) //          
           //       .
         
         {
         ticket=OrderSendX(Symbol(),OP_SELL,Lots,Bid,Slippage,0,0,"",Magic,0,Green);
         if(ticket>0)
         {
              SL = NormalizeDouble(bbUP + IndentSL * Point , Digits);
              //TP=NormalizeDouble(bbDWN-IndentTP * Point , Digits);
              OrderModifyX(ticket, OrderOpenPrice(), SL, 0, 0);
         }//if(ticket>0)
         }//if(Bid<=(e_ma>=E_ma) && (bbDWN<=vhod))
         }//if(CountTrades()==0)
         }//if ((Hvkl == true && (Hour() >= HaurStart && Hour() <= HaurEnd)) || Hvkl == false)
         
   return(0);
   
  }
//+------------------------------------------------------------------+
void CloseOrders()
{
  double bbUP_1=iCustom(Symbol(),PERIOD_M15,"TMA with Distances",TimeFrame,HalfLength,Price,ATRMultiplier,ATRPeriod,Interpolate,1,0);
  double bbDWN_1=iCustom(Symbol(),PERIOD_M15,"TMA with Distances",TimeFrame,HalfLength,Price,ATRMultiplier,ATRPeriod,Interpolate,2,0);
  
for(int i = OrdersTotal()-1; i>=0; i--)
{
if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
{
if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
{
if (OrderType() == OP_BUY) 
{
if(Bid>=bbUP_1)
{
OrderClose(OrderTicket(),OrderLots(),Bid,1,Aqua);              
}//if(Bid>=bbUP_1)
}//if (OrderType() == OP_BUY)
if (OrderType() == OP_SELL)
{
if(Ask<=bbDWN_1)
{
OrderClose(OrderTicket(),OrderLots(),Ask,1,Aqua);
}//if(Ask<=bbDWN_1)
}//if (OrderType() == OP_SELL)
}//if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
}//if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
}//for(int i = OrdersTotal()-1; i>=0; i--)
}
//+------------------------------------------------------------------+

bool OrderModifyX(int ticket,double price,double stoploss,double takeprofit,datetime expiration,color arrow_color=CLR_NONE) 
  {
  if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES ))
  {
 
  ChekValidStop(Symbol(),price,stoploss);
  int err=GetLastError();
      err=0;
      
      int Retry=10;
      int cnt=0;
      bool exit_loop = false;
      bool result;
      
      while(!exit_loop)
      {
      result=OrderModify(ticket,price,stoploss,takeprofit,expiration,arrow_color);
      err=GetLastError();
      if(result==true)
      {
      Comment("\n   " +ticket+ "    ! ");
         return(true);
       }// if(result==true) 
         switch(err)
   {
     
      case  ERR_NO_ERROR:
            exit_loop=true;
            break;
            
            case ERR_INVALID_STOPS:
            case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_TRADE_TIMEOUT:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
            cnt++;
            break;
            case ERR_INVALID_TICKET:
            //case ERR_INVALID_STOPS:
            case ERR_INVALID_PRICE:
            case ERR_PRICE_CHANGED:
            case ERR_OFF_QUOTES:
            case ERR_REQUOTE:
                 RefreshRates();
                 continue;
                 default:
                 
             exit_loop=true;
             break;
             
         }//switch(err)
      }//while(!exit_loop)
      
      if(err != ERR_NO_ERROR)
      {
      Comment( "\n   ,ticket " + ticket);
      Comment("\n   !  " + err);
      
      }//if(err != ERR_NO_ERROR)
  }
  else
  {
  Comment("\n      ,ticket " + ticket);
  return(false);
  }
}//if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES ))
  //+------------------------------------------------------------------+
  void ChekValidStop(string symbol,double price,double & Sl)
  {
  if(Sl==0)
  return;
  double Serves_Min_Stop=MarketInfo(symbol,MODE_STOPLEVEL)*MarketInfo(symbol,MODE_STOPLEVEL);
  if(MathAbs(price-Sl) <= Serves_Min_Stop)
  {
  if(price>Sl)
     Sl=price-Serves_Min_Stop;
     else
     Sl=price+Serves_Min_Stop;
     
   }//if(MathAbs(price-sl) <= Serves_Min_Stop)
   Sl=NormalizeDouble(Sl,MarketInfo(symbol, MODE_DIGITS));
  }
//+------------------------------------------------------------------+
double LotsOptimized() {
       double minlot = MarketInfo(Symbol(), MODE_MINLOT);
       double maxlot = MarketInfo(Symbol(), MODE_MAXLOT);       
       double lot = Lots;
       int orders = OrdersHistoryTotal();
       int losses = 0;
       lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk / balans, 2);
       if (DecreaseFactor > 0.0) {
for (int i = orders - 1; i >= 0; i--) {
       if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) == FALSE) {
       Print("Error in history!");
       break;
       }
if (OrderSymbol() != Symbol() || OrderType() > OP_SELL) continue;
if (OrderProfit() > 0.0) break;
if (OrderProfit() < 0.0) losses++;
}
if (losses > 1) lot = NormalizeDouble(lot - lot * losses / DecreaseFactor, 2);
}
if(lot < minlot) lot = minlot;
if(lot > maxlot) lot = maxlot; 
return (lot);}
//+------------------------------------------------------------------+
int OrderSendX( string symbol, int cmd, double volume, double price, int slippage, double stoploss, double takeprofit,
   string comment, int magic=0, datetime expiration=0, color arrow_color=CLR_NONE)
   {
   
   int err=GetLastError();
   err=0;
   bool exit_loop = false;
   int Retry=10;
   int cnt=0;
   
   
   
   if(cmd==OP_BUY || cmd==OP_SELL)
   {
   while(!exit_loop)
   {
   int ticket=OrderSend(symbol,cmd,volume,price,slippage,stoploss,takeprofit,comment,magic,expiration,arrow_color);
   
    
   err=GetLastError();
   switch(err)
   {
     
      case  ERR_NO_ERROR:
            exit_loop=true;
            break;
            
            case ERR_SERVER_BUSY:
            case ERR_NO_CONNECTION:
            case ERR_TRADE_TIMEOUT:
            case ERR_BROKER_BUSY:
            case ERR_TRADE_CONTEXT_BUSY:
            cnt++;
            break;
            
            case ERR_INVALID_PRICE:
            case ERR_PRICE_CHANGED:
            case ERR_OFF_QUOTES:
            case ERR_REQUOTE:
                 RefreshRates();
                 continue;
                 default:
                 
             exit_loop=true;
             break;
   }//switch(err)
   if(cnt>Retry)
   exit_loop=true;
   
   if(!exit_loop)
   {
   Sleep(2000);
   RefreshRates();
   }//if(!exit_loop)
   else
   {
   if(err !=ERR_NO_ERROR)
   {
   Comment("\n "+err);
   
   }
   }//if(err !=ERR_NO_ERROR)
   if(err==ERR_NO_ERROR)
   {
   OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES);
   return(ticket);
   }
   Comment("\n     " +cnt+"  ");
   return(-1);
  }//while(!exit_loop)
 }//if(cmd==OP_BUY || cmd==OP_SELL)
} 
//+------------------------------------------------------------------+
int CountBuy()
 {
 int count = 0;
 for(int trade = OrdersTotal()-1; trade >=0; trade--)
 {
 OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
 if(OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
 {
 if(OrderType() == OP_BUY)
 count++;
 }
 }
 return(count);
 }
 //+------------------------------------------------------------------+
  int CountSell()
 {
 int count = 0;
 for(int trade = OrdersTotal()-1; trade >=0; trade--)
 {
 OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
 if(OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
 {
 if(OrderType() == OP_SELL)
 count++;
 }
 }
 return(count);
 }
 //+------------------------------------------------------------------+//+------------------------------------------------------------------+